"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _clientCloudwatch = require("@aws-sdk/client-cloudwatch");
var _nodeHttpHandler = require("@smithy/node-http-handler");
var _bluebird = _interopRequireDefault(require("bluebird"));
var _log = require("../utils/log");
/* eslint import/no-extraneous-dependencies: ["error", {"devDependencies": true}] */

class Connector {
  constructor({
    debug,
    timeout = Number(process.env.CW_TIMEOUT) || Number(process.env.TIMEOUT) || 1000
  }) {
    this.debug = msg => debug('%j', msg);
    this.cw = new _clientCloudwatch.CloudWatchClient({
      requestHandler: new _nodeHttpHandler.NodeHttpHandler({
        requestTimeout: timeout,
        connectionTimeout: timeout
      }),
      logger: (0, _log.defaultDebugLogger)(debug)
    });
  }
  put({
    Namespace,
    MetricData
  }) {
    const params = {
      Namespace,
      MetricData
    };
    const command = new _clientCloudwatch.PutMetricDataCommand(params);
    return _bluebird.default.resolve(this.cw.send(command)).tap(this.debug).tapCatch(this.debug);
  }
}
var _default = exports.default = Connector;